#!/usr/bin/make -f

cmake: clean CMakeLists.txt env
	if [ -n "$(PYTHON)" ]; then swig -c++ -python -o ./lib/libstorage_module.cpp ./lib/pystorage.swig; fi
	cmake -P CBuildLists.txt
	cmake -D DEBUG=$(DEBUG) -D PYTHON=$(PYTHON) . && make VERBOSE=1
	if [ -n "$(PYTHON)" ]; then mv ./lib/lib_storage.so ./lib/_storage.so; fi

env:
	if [ -n "$(DEBUG)" ]; then export DEBUG=1; fi
	if [ -n "$(PYTHON)" ]; then export PYTHON=1; fi

api: cmake
	@echo ""
	@echo "testing libstorage API..."
	@echo ""
	make -C ./tests -f api.make test-lib-c test-lib-cpp
	if [ -n "$(PYTHON)" ]; then make -C ./tests -f api.make test-lib-py; fi
	make -C ./tests -f api.make clean

tarball: cmake
	make package

clean:
	- make clean
	rm -rf CMakeCache.txt CMakeFiles cmake_install.cmake Makefile
	rm -rf src/CMakeFiles src/cmake_install.cmake src/Makefile
	rm -rf lib/CMakeFiles lib/cmake_install.cmake lib/Makefile
	rm -rf _CPack_Packages CPackConfig.cmake CPackSourceConfig.cmake diskutil-*.tar.gz
	rm -rf cmake_uninstall.cmake IMMEDIATE install_manifest.txt
	rm -rf Testing/ CTestTestfile.cmake
	rm -rf _CPack_Packages/ *.tar.gz
	rm -rf config.h build.h
	rm -rf lib/libstorage_module.cpp lib/storage.py lib/storage.pyc lib/_storage.so
