
#include "storages.hpp"
#include "partitions.hpp"

#ifndef _disks_hpp
#define _disks_hpp

#include <cstdio>
#include <iostream>

#include <fcntl.h>
#include <unistd.h>
#include <errno.h>
#include <string.h>
#include <stdlib.h>
#include <limits.h>
#include <sys/stat.h>
#include <parted/parted.h>
#include <wait.h>

#define    _GNU_SOURCE
#define    BLKSIZE                512
#define    MBR_SYM                4
#define    MBR_SIGN_OFFSET        2
#define    MBR_SIGN               "55AA"

#define    PART1_OFFSET_BEGIN     66
#define    PART1_OFFSET_END       50

#define    NAME                   "diskutil"

#ifdef __cplusplus

class disks : public storages
{
	public:
		/* methods */
		int dump();
		int read_mbr();
		int print_mbr();
		
		int list(char arg[PATH_MAX]);
		int list_all();
		
		int smart();
		
		/* properties */
		char* device;
		char mbr[BLKSIZE];
		partitions partition1;
		partitions partition2;
		partitions partition3;
		partitions partition4;
};

extern "C" {
#endif /* __cplusplus */

/* section with basic external C API */
int disks_list_all(void);

#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* _disks_hpp */
