
#include "logging.hpp"

logging log;


logging::logging()
{
	counter = 0;
}

/* generate debug log message */
int logging::debug(char *file, const char *call, const char *state, int line, int result)
{
	char *basefile = basename(file);
	if (result == UNKNOWN) {
		/* NAME: DEBUG: FILE: type function (args): LINE: state */
		printf("%s: %s: %s: %s: %d: %s\n", NAME, "DEBUG", basefile, call, line, state);
	} else {
		/* NAME: DEBUG: FILE: type function (args): LINE: return = N */
		printf("%s: %s: %s: %s: %d: %s: return = %d\n", NAME, "DEBUG", basefile, call, line, state, result);
	}
	
	return 0;
}

/* generate verbose log message */
int logging::verbose(const char *action, const char *info, int result)
{
	if (result == UNKNOWN) {
		printf("%s: %s: %s: %s\n", NAME, "LOG", action, info);
	} else {
		printf("%s: %s: %s %d\n", NAME, action, info, result);
	}
	
	return 0;
}

int logging::push(char *file, const char *name, const char *info, int line)
{
	strcpy(trace[counter].file, basename(file));
	strcpy(trace[counter].name, name);
	strcpy(trace[counter].info, info);
	trace[counter].line = line;
	counter++;
	return 0;
}

int logging::pop()
{
	/* NAME: CALL: NUM : FILE : FUNCTION : LINE: [enter|return] */
	printf("\n======= CALL TRACE =========\n");
	for (int i = 0; i < counter; i++) {
		printf("%s: CALL: %.4d : %s : %s : %4.4d: %s\n", NAME, i, trace[i].file, trace[i].name, trace[i].line, trace[i].info);
	}
	printf("======= CALL TRACE =========\n\n");
	return 0;
}

void logging::sig(int num)
{
	//printf("Received signal %d\n", num);
	printf("\n ====== SEGMENTATION FAULT ====== \n");
	log.pop();
	exit(11);
}
