
#ifndef _logging_hpp
#define _logging_hpp

#include <cstdio>
#include <string.h>
#include <stdlib.h>
#include <signal.h>
#include <libgen.h>

#define    NAME       "diskutil"
#define    VERSION    "0.0.0"
#define    UNKNOWN    -1

#define    LOG_PUSH_ENTER     __FILE__, __PRETTY_FUNCTION__, "enter", __LINE__
#define    LOG_PUSH_RETURN    __FILE__, __PRETTY_FUNCTION__, "return", __LINE__

#define    LOG_DEBUG          __FILE__, __PRETTY_FUNCTION__, "exec", __LINE__, UNKNOWN
#define    LOG_DEBUG_(r)       __FILE__, __PRETTY_FUNCTION__, "exec", __LINE__, r


class logging
{
	public:
		logging();
		/* methods */
		int debug(char *file, const char *call, const char *state, int line, int result);
		int verbose(const char *action, const char *info, int result);
		int push(char *file, const char *name, const char *info, int line);
		int pop();
		void sig(int num);

		/* properties */
		int counter;
		struct stack {
			char file[255];
			char name[255];
			char info[255];
			int line;
		} trace[1024];
};

extern logging log;

#endif /* _logging_hpp */
