
#include "routine.h"


int exec(char *cmd, char *const args[])
{
	int status;
	pid_t child;
	if (!(child = fork())) {
		execvp(cmd, args);
		exit(0);
	}
	waitpid(child, &status, 0);
	if (WIFEXITED(status) && WEXITSTATUS(status) == 0) {
		return 0;
	} else {
		return -1;
	}
}

#ifdef ROOT_HELPER
int root(const char *argv[])
{
	/* init buffer for arguments */
	char *args[PATH_MAX];
	if (!((strcmp(ROOT_HELPER, "sudo") == 0) || (strcmp(ROOT_HELPER, "gksudo") == 0))) {
		return E_CROOT;
	}
	args[0] = ROOT_HELPER;
	/* copy input arguments */
	int i = 0, j = 1;
	while(argv[i])
		args[j++] = argv[i++];
	/* init getting root */
	int status;
	pid_t child;
	/* init root handler for getting rights */
	if (!(child = fork())) {
		execvp(ROOT_HELPER, args);
		exit(0);
	}
	/* wait for get root and return result */
	waitpid(child, &status, 0);
	if (WIFEXITED(status)) {
		if (WEXITSTATUS(status) != E_CROOT) {
			return WEXITSTATUS(status);
		} else {
			printf("%s: %s: cannot get administrative rights to perform action\n", NAME, "ERROR");
			return E_CROOT;
		}
	}
}
#endif
