
#include "../config.h"

#ifndef _routine_h
#define _routine_h

#ifdef __cplusplus
extern "C" {
#endif

#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <dirent.h>
#include <assert.h>
#include <sys/wait.h>

#define    NAME           "diskutil"
#define    E_CROOT        -1


int exec(char *cmd, char *const args[]);
#ifdef ROOT_HELPER
int root(const char *argv[]);
#endif


#if defined __llvm__
#	define SEGFAULT_CALLBACK signal(SIGSEGV, (__sighandler_t)(log.sig));
#else
#	if defined __GNUG__
#		define SEGFAULT_CALLBACK signal(SIGSEGV, (void (*)(int)) &logging::sig);
#	else
#		define SEGFAULT_CALLBACK
#	endif
#endif

#if defined DEBUG
#	define ASSERT(a) assert(a);
#else
#	define ASSERT(a)
#endif

#ifdef __cplusplus
}
#endif

#endif /* _routine_h */
