/* ./archives /path/to/file/archive.tar.gz /path/to/mounted/home/user/.gvfs/archive.tar.gz */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <libgen.h>
#include <limits.h>

int is_gvfs_path(char const* path)
{
	char *gvfs = "/.gvfs/";
	int i = 0, j = 0, k = 0, r = 0;
	for (i = 0; i < strlen(path); i++) {
		j = 0;
		if (path[i] == gvfs[j]) {
			k = i;
			while(path[++k] == gvfs[++j]) {
				;
			}
			if (j == strlen(gvfs)) {
				r = 1;
			}
		}
	}
	return r;
}

int main(int argc, char const* argv[])
{
	char *archive = argv[1];
	printf("archive = %s\n", archive);
	
	char archive_path[PATH_MAX];
	realpath(archive, archive_path);
	/* TODO: add checking for existing */
	printf("archive_path = %s\n", archive_path);
	
	char gvfs_archive_path[PATH_MAX];
	int i = 0, j = 0;
	for (i = 0; i < strlen(archive_path); i++) {
		if (archive_path[i] == '/') {
			/* authors of gvfsd-archive frontend cannot into URI decode */
			gvfs_archive_path[j++] = '%';
			gvfs_archive_path[j++] = '2';
			gvfs_archive_path[j++] = '5';
			gvfs_archive_path[j++] = '2';
			gvfs_archive_path[j++] = 'F';
		} else {
			gvfs_archive_path[j++] = archive_path[i];
		}
	}
	
	char *gvfs_prefix = "archive://file%253A%252F%252F";
	printf("%s\n", gvfs_prefix);
	
	char gvfs_archive[PATH_MAX];
	strcpy(gvfs_archive, gvfs_prefix);
	strcat(gvfs_archive, gvfs_archive_path);
	printf("result = %s\n", gvfs_archive);
	
	char *gvfs_home = "~/.gvfs/";
	char mount_point[PATH_MAX];
	strcpy(mount_point, gvfs_home);
	strcat(mount_point, basename(archive_path));
	
	printf("mount = %s\n", mount_point);
	
	printf("====\n");
	char *test = argv[2];
	if (is_gvfs_path(test)) {
		printf("unmount\n");
	} else {
		printf("not gvfs\n");
		/*
		resolve
		basename
		umount
		*/
	}
	
	return 0;
}
