
#define _BSD_SOURCE
#include <sys/types.h>
#include <sys/stat.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <dirent.h>
#include <errno.h>
#include <limits.h>

char list[PATH_MAX][PATH_MAX];

int list_block_devices(const char* directory, int n)
{
	/* init path */
	char path[PATH_MAX];
	/* create structs */
	struct stat st;
	struct dirent *entry;
	/* open directory for access */
	DIR *dir = opendir(directory);
	/* process content of directory */
	while((entry = readdir(dir)) != NULL) {
		if ((strcmp(entry->d_name, ".") != 0) && (strcmp(entry->d_name, "..") != 0)) {
			/* process files/dirs in directory */
			strcpy(path, directory);
			strcat(path, "/");
			strcat(path, entry->d_name);
			/* get info about current file */
			if (lstat(path, &st) == 0) {
				if (S_ISDIR(st.st_mode)) {
					/* if file is directory, process it recursivly */
	//				n = list_block_devices(path, n, list);
				} else {
					if (S_ISBLK(st.st_mode)) {
						if (major(st.st_rdev) == 8) {
							printf("%s\n", path);
							strcpy(list[n], path);
							n++;
						}
					}
				}
			} else {
				fprintf(stderr, "%s: %s: cannot get information from %s (%s)\n", "size", "ERROR", path, strerror(errno));
			}
		}
	}
	/* release directory */
	closedir(dir);
	/* exit */
	return n;
}

int sort_block_devices()
{
	char *string1 = "/dev/sdb2";
	char *string2 = "/dev/sdb1";
	//int c1 = 0, c2 = 0;
	int i = 0;
	for (i = 0; i < strlen(string1); i++) {
		if (((char) string1[i]) == ((char) string2[i])) {
			continue;
		} else if (((char) string1[i]) < ((char) string2[i])) {
			printf("%s\n", string1);
			printf("%s\n", string2);
		} else {
			printf("%s\n", string2);
			printf("%s\n", string1);
		}
	}
	return 0;
}

int main(int argc, const char *argv[])
{
	printf("%d\n", strcmp("/dev/sda1", "/dev/sdb10"));
	int num = 0;
	num = list_block_devices("/dev", num);
	printf("n of block devices = %d\n", num);
	printf("%s\n", list[0]);
	
	printf("sorting...\n");
	sort_block_devices();
	
	return 0;
}
