
#include <ext2fs/ext2_fs.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <stdlib.h>
#include <string.h>

#define boot_block_size 1024

int main(int argc, const char *argv[])
{
	char *buff = (char *)malloc(sizeof(struct ext2_super_block));

	struct ext2_super_block * sblock = (struct ext2_super_block *)malloc(sizeof(struct ext2_super_block));

	//open any partition for testing,must be ext2/ext3.
	int fd = open("/dev/sda5",O_RDONLY);

	//skip the boot block
	lseek(fd,boot_block_size,SEEK_CUR);

	//read the superblock raw data from disk to buff
	read(fd,buff,sizeof(struct ext2_super_block));

	//copy buffer to sblock, you can use casting or union for this.
	memcpy((void *)sblock,(void *)buff,sizeof(struct ext2_super_block));

	printf("Mmagic number = %u\n",sblock->s_magic);
	if (sblock->s_magic == EXT2_SUPER_MAGIC) {
		printf("FS = EXT_N\n");
	}
	close(fd);

	return 0;
}
