
#define _BSD_SOURCE
#include <sys/types.h>
#include <sys/stat.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <dirent.h>
#include <errno.h>
#include <limits.h>

int list_block_devices(const char* directory, int n)
{
	/* init path */
	char path[PATH_MAX];
	/* create structs */
	struct stat st;
	struct dirent *entry;
	/* open directory for access */
	DIR *dir = opendir(directory);
	/* process content of directory */
	while((entry = readdir(dir)) != NULL) {
		if ((strcmp(entry->d_name, ".") != 0) && (strcmp(entry->d_name, "..") != 0)) {
			/* process files/dirs in directory */
			strcpy(path, directory);
			strcat(path, "/");
			strcat(path, entry->d_name);
			/* get info about current file */
			if (lstat(path, &st) == 0) {
				if (S_ISDIR(st.st_mode)) {
					/* if file is directory, process it recursivly */
					n = list_block_devices(path, n);
				} else {
					if (S_ISBLK(st.st_mode)) {
						if (major(st.st_rdev) == 8) {
							printf("%s\n", path);
							n++;
						}
					}
				}
			} else {
				fprintf(stderr, "%s: %s: cannot get information from %s (%s)\n", "size", "ERROR", path, strerror(errno));
			}
		}
	}
	/* release directory */
	closedir(dir);
	/* exit */
	return n;
}

int main(int argc, const char *argv[])
{
	int num = 0;
	num = list_block_devices("/dev", num);
	printf("n of block devices = %d\n", num);
	
	return 0;
}
