
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <sys/wait.h>

int exec(char *cmd, char *const args[])
{
	int status;
	pid_t child;
	if (!(child = fork())) {
		execvp(cmd, args);
		exit(0);
	}
	waitpid(child, &status, 0);
	if (WIFEXITED(status) && WEXITSTATUS(status) == 0) {
		return 0;
	} else {
		return -1;
	}
}

int main(int argc, const char *argv[])
{
	setuid(0);
	printf("getuid: %d\n", getuid());
	printf("geteuid: %d\n", geteuid());
	char *cmd = "mount";
	char *const args[] = {cmd, "-text2", "-oloop", "./32mb.dd", "./pnt", NULL};
	
	printf("exec: %d\n", exec(cmd, args));
	
	return 0;
}
