
#include <stdio.h>
#include <parted/parted.h>

#define MEGABYTE 1048576

void print_PedGeometry(PedGeometry *g)
{
	printf("start sector: %lli\n",g->start);
	printf("end sector: %lli\n",g->end);
	printf("length: %lli\n",g->length);
}


int main (void)
{
	PedDevice* device = NULL;
	PedDisk* disk = NULL;
	PedPartition* part = NULL;
	PedGeometry geom;

	PedGeometry *g;

	unsigned long size;
	double length;
	PedSector p_size;
	char *fsname;

	ped_device_probe_all ();

	while ((device = ped_device_get_next(device))) {
		disk = ped_disk_new(device);
		p_size = device->length;
		size = p_size/MEGABYTE;
		size = size * device->sector_size;
		printf("%s name: %s size: %uMB\n",device->path,device->model,size);
		for (part = ped_disk_next_partition (disk, NULL); part; part = ped_disk_next_partition (disk, part)) {
			geom = part->geom;
			g = &part->geom;
			length = (double)geom.length/MEGABYTE*device->sector_size;
			if(part->fs_type) {
				fsname = (char*)part->fs_type->name;
			} else {
				fsname = "unknown";
			}
			print_PedGeometry(g);
			printf("\t%s%d %10.2fMB %s\n",device->path, part->num,length,fsname);
		}
	}
	return 0;
}
