/*
 * source:
 * http://stackoverflow.com/questions/2262386/generate-sha256-with-openssl-and-c
 */

#include <stdio.h>
#include <openssl/sha.h>
#include <string.h>
#include <stdlib.h>

void sha256(char *string, unsigned char outputBuffer[65])
{
	unsigned char hash[SHA256_DIGEST_LENGTH];
	SHA256_CTX sha256;
	SHA256_Init(&sha256);
	SHA256_Update(&sha256, string, strlen(string));
	SHA256_Final(hash, &sha256);
	int i = 0;
	for(i = 0; i < SHA256_DIGEST_LENGTH; i++)
	{
		sprintf(outputBuffer + (i * 2), "%02x", hash[i]);
	}
	outputBuffer[64] = 0;
}

int sha256_file(char *path, char outputBuffer[65])
{
	FILE *file = fopen(path, "rb");
	if(!file) return -534;
	
	unsigned char hash[SHA256_DIGEST_LENGTH];
	SHA256_CTX sha256;
	SHA256_Init(&sha256);
	const int bufSize = 32768;
	unsigned char *buffer = malloc(bufSize);
	int bytesRead = 0;
	if(!buffer) return -5;
	while((bytesRead = fread(buffer, 1, bufSize, file)))
	{
		SHA256_Update(&sha256, buffer, bytesRead);
	}
	SHA256_Final(hash, &sha256);
	//sha256_hash_string(hash, outputBuffer);
	fclose(file);
	free(buffer);
	return 0;
}

int main(int argc, char const* argv[])
{
	unsigned char buffer[65];
	sha256("string", buffer);
	printf("%s\n", buffer);
	return 0;
}
