#!/bin/bash
# tiny shell manager for diskutil hooks


install-gnome2()
{
	cp diskutil-hook.desktop ${HOME}/.config/autostart/
}

remove-gnome2()
{
	rm "${HOME}/.config/autostart/diskutil-hook.desktop"
}

install-boot()
{
	echo ib
}

remove-boot()
{
	echo rb
}


actions="install-gnome2 remove-gnome2 install-boot remove-boot"
USAGE="Usage: diskutil-hook-manager.sh <action>
  actions: ${actions}"

if [ ${#} -ne 1 ] ; then
	echo "${USAGE}"
	exit 0
fi;

action="${1}"

for a in ${actions}; do
	if [ "${a}" == "${action}" ] ; then
		match="1"
	fi;
done;

if [ -z ${match} ]; then
	echo "${USAGE}"
	exit 1
fi

${action}
