
#include "../lib/storages.hpp"
#include "../lib/disks.hpp"
#include "../lib/directories.hpp"
#include "../lib/archives.hpp"
#include "../lib/routine.h"
#include "../build.h"

#ifndef _options_hpp
#define _options_hpp

#include <cstdio>

#include <string.h>
#include <getopt.h>
#include <limits.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <parted/parted.h>


class options {
	public:
		options();
		/* methods */
		int parse(int argc, const char *argv[]);
		int get_arg_type();
		int get_block_type(const char *arg);
		int get_arch_type(char *arg);
		
		int actions(disks *disk);
		int actions(partitions *partition);
		int actions(directories *directory);
		int actions(archives *archive);
		
		int usage();
		int version();
		
		/* properties */
		char *type;
		char action[255];
		char arg[PATH_MAX];
		char path[PATH_MAX];
		int verbose;
		int debug;
		int trace;
};

extern options args;

#endif /* _options_hpp */
